#define USE_TI89
#define OPTIMIZE_ROM_CALLS

#include <tigcclib.h>

void die(char *);

void _main() {
  ESI args;
  FILE *infile, *outfile;
  char *in, *out, *codeword;
  int len, i;
  short c;

  if(ArgCount() < 2) die("Too few arguments"); 
  if(ArgCount() > 2) die("Too many arguments");

  args = top_estack;

  if(GetArgType(args) != STR_TAG) die("Argument must be string");
  in = (char *) GetStrnArg(args);

  if(GetArgType(args) != STR_TAG) die("Argument must be a string");
  codeword = (char *) GetStrnArg(args);

  infile = fopen(in, "rb");
  if(! infile) die("Can't open input");

  out = tmpnam(NULL);
  outfile = fopen(out, "wb");
  if(! outfile) die("Can't create output buffer");

  len = strlen(codeword);
  if(len == 0) die("The codeword can't be blank!");

  i = 0;
  while((c = fgetc(infile)) != EOF) {
    fputc(((char)c) ^ codeword[i], outfile);
    if(++i == len) i = 0;
  }

  fclose(infile);
  fclose(outfile);

  if(! SymDel(SYMSTR(in))) die("Can't write output.");
  if(! SymMove(SYMSTR(out), SYMSTR(in))) die("Can't write output."); 
    
}

void die(char *msg) {
	DlgMessage("ERROR", msg, BT_CANCEL, BT_NONE);
	abort();
}
